package
{
	import away3d.cameras.Camera3D;
	import away3d.cameras.lenses.LensBase;
	import away3d.containers.ObjectContainer3D;
	import away3d.containers.Scene3D;
	import away3d.containers.View3D;
	import away3d.core.base.Object3D;
	import away3d.events.*;
	import away3d.lights.DirectionalLight;
	import away3d.lights.PointLight;
	import away3d.lights.shadowmaps.ShadowMapperBase;
	import away3d.loading.*;
	import away3d.materials.*;
	import away3d.materials.utils.CubeMap;
	import away3d.primitives.Cube;
	import away3d.primitives.Plane;
	import away3d.primitives.SkyBox;
	import away3d.primitives.Sphere;
	
	import com.greensock.*;
	
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.*;
	import flash.geom.Vector3D;
	
	[SWF(backgroundColor="#000000", frameRate = 30, quality = "Best")]

	public class demo3D extends Sprite
	{
		private var container:ObjectContainer3D
		private var view:View3D;
		private var cube:Cube;
		private var mat:ColorMaterial;
		private var camera:Camera3D;
		private var light:PointLight;
		private var scene:Scene3D;
		private var etape:int=0;
		private var tweenMax:TweenMax;

		public function demo3D()
		{
			
			
			// set up the stage
			stage.align = StageAlign.TOP_LEFT;
			stage.scaleMode = StageScaleMode.NO_SCALE;

			scene = new Scene3D();
			
			camera = new Camera3D();
			
			view = new View3D(scene,camera);
		
			addChild(view);
			light = new PointLight();
			light.color = 0xFFFFFF;
			light.diffuse = 1;
			light.specular = 0.5;
			
			light.x = 100;
			light.y = 100;
			light.z = -500;
			
			view.scene.addChild(light);
			
			
			container = new ObjectContainer3D();
			
			camera.z=-350;
		
			for(var i:int=0; i<16; i++){
				for(var j:int=0; j<16; j++){
			mat = new ColorMaterial(0xFFFFFF*Math.random(),1);
			
			
			mat.lights = [light];
			mat.ambient = 1;
			mat.ambientColor = 0x111133;
			mat.specular = 0.8;
			
			cube = new Cube(mat,20,20,20);
			cube.x = -128+i*20;
			cube.y = -128+j*20;
			cube.z = (Math.pow(cube.x,2)-Math.pow(cube.y,2))*0.008;
			
			
			
			container.addChild(cube);
			
			}
			}
			view.scene.addChild(container);
			addEventListener(Event.ENTER_FRAME, onEnterFrame);
			stage.addEventListener(MouseEvent.CLICK, progressing);
			
		}
		
		private function onEnterFrame(e:Event):void{
			container.yaw(.5);
			container.roll(.5);
			view.render();
			
		}
		
		private function progressing(e:MouseEvent):void{
			switch(etape){ //TWEENING
				case 1:
					etape = 2;
					for(var i:int=0; i<256; ++i){
						var t:Cube = Cube(container.getChildAt(i));
						TweenMax.to(t,1,{z:(t.x*Math.pow(t.y,3)-t.y*Math.pow(t.x,3))*0.0000003});						
					}
					break;
				
				case 2:
					etape = 3;
					for(var i:int=0; i<256; ++i){
						var t:Cube = Cube(container.getChildAt(i));
						TweenMax.to(t,1,{z:(Math.pow(t.x,2)-Math.pow(t.y,2))*0.008});
					}
					break;
				case 3:
					etape = 0;
					for(var i:int=0; i<256; ++i){
						var t:Cube = Cube(container.getChildAt(i));
						TweenMax.to(t,1,{z:0});						
	}
					break;
				default:
					etape = 1;
					for(var i:int=0; i<256; ++i){
					var t:Cube = Cube(container.getChildAt(i));
					TweenMax.to(t,1,{z:(Math.pow(t.x,3)-Math.pow(t.y,2))*0.00005});
					}
					break;
			}
		}
		
		
		
	}
}